

%% Solution to HW3 Question 10601 Fall 09 
%% oznur@cs.cmu.edu, October 2009

% clear the environment
clear ;
file='prostatecancer.csv';
%Import and restructure the data
allData=importdata(file);



%%%% 3.1.1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% correlation matrix
data = allData.data (:,2:11) ;
corrMat = corrcoef (data(:,1:9) );
%print correlation mat

corrMat
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%% 3.2%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

train.X = data (logical(( data ( : , 10)==1)) ,1:8);
val.X = data (logical(( data ( : , 10)==2)) ,1:8);
test.X = data (logical((data ( : , 10)==3)) ,1:8);


train.Y = data (logical(( data ( : , 10)==1)), 9);
val.Y = data (logical(( data ( : , 10)==2)), 9);
test.Y = data (logical((data ( : , 10)==3)), 9);



% for all models the Y values are the same
Model1.trainY=train.Y;
Model1.valY=val.Y;
Model1.testY=test.Y;

Model2.trainY=train.Y;
Model2.valY=val.Y;
Model2.testY=test.Y;

Model3.trainY=train.Y;
Model3.valY=val.Y;
Model3.testY=test.Y;

%%% Model 1%%%
%Construct the first model design matrix
Model1.trainX=train.X; %features are the attributes

% get the mean and std of the training data
Model1.train_mean=mean(Model1.trainX);
Model1.train_std=std(Model1.trainX);
% scale and add the intercept term
Model1.scaled_trainX=scaleVec(Model1.trainX,Model1.train_mean,Model1.train_std); %scale to zero mean unit variance
Model1.scaled_trainX=addIntercept(Model1.scaled_trainX); %% add the column 1 vector

%features are the attributes
Model1.valX=val.X; 

Model1.scaled_valX = scaleVec(Model1.valX,Model1.train_mean,Model1.train_std); %scale X
Model1.scaled_valX = addIntercept(Model1.scaled_valX);

% find the least square fit
Model1.W=lregress(Model1.trainY, Model1.scaled_trainX);

% print weights for model1 
fprintf ('\n--------------\nWeigths in Model1\n');
fprintf ('%0.5f,',Model1.W');
fprintf ('\n--------------\n');

%%% Model 2%%%
%construct the second model 
Model2.trainX=train.X; % individual terms
Model2.valX=val.X;
% add the interaction terms 
index=9;

for i=1:5
    for j=i+1:6      
          Model2.trainX(:,index)=train.X(:,i).*train.X(:,j);
          Model2.valX(:,index)=val.X(:,i).*val.X(:,j);     
          
          index=index+1;        
    end
end

%% get the mean and std of the training data
Model2.train_mean=mean(Model2.trainX);
Model2.train_std=std(Model2.trainX);

Model2.scaled_trainX=scaleVec(Model2.trainX,Model2.train_mean,Model2.train_std); %scale
Model2.scaled_trainX=addIntercept(Model2.scaled_trainX); % add the column 1 vector


% scale and add the intercept term
Model2.scaled_valX=scaleVec(Model2.valX,Model2.train_mean,Model2.train_std); %scale X
Model2.scaled_valX=addIntercept(Model2.scaled_valX);

%find the least square fit
Model2.W=lregress(Model2.trainY,Model2.scaled_trainX);  

fprintf ('\n--------------\nWeigths in Model2\n');
fprintf ('%0.5f,',Model2.W');
fprintf ('\n--------------\n');

%%%% Model 3  
Model1.W(2:9,1)
[dump rank]=sort(abs(Model1.W(2:9,1)));
index=1;

%dump 4 features with smallest weight
for i=5:size(rank,1)
    j=size(rank,1)-i+1;
    Model3.trainX(:,index)=train.X(:,j);
    Model3.valX(:,index)=val.X(:,j);    
    index=index+1;
end
Model3.train_mean=mean(Model3.trainX);
Model3.train_std=std(Model3.trainX);

Model3.scaled_trainX=scaleVec(Model3.trainX,Model3.train_mean,Model3.train_std); %scale
Model3.scaled_trainX=addIntercept(Model3.scaled_trainX); % add the column 1 vector

Model3.scaled_valX=scaleVec(Model3.valX,Model3.train_mean,Model3.train_std); %scale X
Model3.scaled_valX=addIntercept(Model3.scaled_valX);

%find the least square fit
Model3.W=lregress(Model3.trainY,Model3.scaled_trainX);    

sprintf ('\n--------------\nWeigths in Model3\n');
sprintf ('%0.5f,',Model3.W');
sprintf ('\n--------------\n');

%%%%% Calculate training error and test errors %%%%
%Calculate yhat for the training 
Model1.trainYhat=Model1.scaled_trainX*Model1.W;
Model2.trainYhat=Model2.scaled_trainX*Model2.W;
Model3.trainYhat=Model3.scaled_trainX*Model3.W;

%Calculate yhat for the validation data
Model1.valYhat=Model1.scaled_valX*Model1.W;
Model2.valYhat=Model2.scaled_valX*Model2.W;
Model3.valYhat=Model3.scaled_valX*Model3.W;


%Calculate training errors
Model1.trainMSE=MSE(Model1.trainYhat,Model1.trainY);
Model2.trainMSE=MSE(Model2.trainYhat,Model2.trainY);
Model3.trainMSE=MSE(Model3.trainYhat,Model3.trainY);

%Calculate validation errors
Model1.valMSE=MSE(Model1.valYhat,Model1.valY);
Model2.valMSE=MSE(Model2.valYhat,Model2.valY);
Model3.valMSE=MSE(Model3.valYhat,Model3.valY);

%Make a table to compare models

trainErr=[Model1.trainMSE,Model2.trainMSE,Model3.trainMSE];
valErr=[Model1.valMSE,Model2.valMSE,Model3.valMSE];

%%Plot 2 bar charts for training and validation errors
%Plot the training error as a bar graph
figure(1); clf();
set(gca(), 'FontSize', 16);
bar(trainErr);
title('Training Error of the Three Models');
colormap('gray');
xlabel('Model ID');
ylabel('Training MSE');

%Plot the validation error as a bar graph

figure(2); clf();
set(gca(), 'FontSize', 16);
bar(valErr);
title('Validation Error of the Three Models');
colormap('gray');
xlabel('Model ID');
ylabel('Validation MSE');
trainErr
valErr

%% End of 3.2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 3.3

%% Ridge regression
Err = zeros (50,3 ) ;
W = zeros(1,24);

for i = -30:19
    
    Err(i+31,1)=i; 
    
    regW=ridgeregress(Model2.trainY,Model2.scaled_trainX,2^i);
    trainYhat=Model2.scaled_trainX*regW;
    valYhat=Model2.scaled_valX*regW;    
    
    W= [W; regW' ] ;
    Err( i +31 ,2) = MSE(trainYhat,Model2.trainY) ;
    Err( i +31 ,3) = MSE(valYhat,Model2.valY) ; 
end

figure(3);
set(gca(), 'FontSize', 16);
title('Regularization Curve for Model2');
plot (Err(:,1),Err(:,2),'r-','LineWidth',2);

hold on;
plot (Err(:,1),Err(:,3),'b-','LineWidth',2);
legend('training error','testing error');

xlabel('log2(lambda)');
ylabel('MSE');

[x ind]=min (Err(:,3));
lambdastar=2^Err(ind,1)
fprintf ('>Lambda that minimizes the validation error\t %d\n',2^Err(ind,1));
fprintf ('>Model 2 regularized with minimum validation error (lambda=16)\n Training Error: %0.5f, Validation Error: %0.5f\n',Err(ind,2),Err(ind,3));
fprintf ('>Model 2 unregularized\n Training Error: %0.5f, Validation Error: %.5f\n',Model2.trainMSE,Model2.valMSE);



% 3.4 Final Model = Model2 wi th lambda = 2^4

% 3.4 Final Model = Model2 wi th lambda = 4
FinalModel.trainX = [Model2.trainX ; Model2.valX ] ;
FinalModel.trainY = [Model2.trainY ;Model2.valY ] ;
FinalModel.testY=Model2.testY;

FinalModel.testX=test.X;
index=9;
for i=1:5
    for j=i+1:6               
          FinalModel.testX(:,index)=test.X(:,i).*test.X(:,j);   
          index=index+1;        
    end
end
FinalModel.train_mean=mean(FinalModel.trainX);
FinalModel.train_std=std(FinalModel.trainX);

FinalModel.scaled_trainX=scaleVec(FinalModel.trainX,FinalModel.train_mean,FinalModel.train_std); %scale
FinalModel.scaled_trainX=addIntercept(FinalModel.scaled_trainX); % add the column 1 vector

FinalModel.scaled_testX=scaleVec(FinalModel.testX,FinalModel.train_mean,FinalModel.train_std);
FinalModel.scaled_testX=addIntercept(FinalModel.scaled_testX);

FinalModel.W=ridgeregress(FinalModel.trainY,FinalModel.scaled_trainX,lambdastar);

FinalModel.trainYhat=FinalModel.scaled_trainX*FinalModel.W;
FinalModel.testYhat=FinalModel.scaled_testX*FinalModel.W;    

FinalModel.trainMSE = MSE(FinalModel.trainYhat,FinalModel.trainY) ;
FinalModel.testMSE = MSE(FinalModel.testYhat,FinalModel.testY) ;

fprintf ('>Final model (Model2 labmda=16)\n Training Error: %0.5f, Validation Error: %0.5f\n',FinalModel.trainMSE,FinalModel.testMSE);








